## curl 7.25.0

=== CMakeLists.txt ===
# cURL/libcurl CMake script
# by Tetetest and Sukender (Benoit Neil)

# TODO:
# The output .so file lacks the soname number which we currently have within the lib/Makefile.am file
# Add full (4 or 5 libs) SSL support
# Add INSTALL target (EXTRA_DIST variables in Makefile.am may be moved to Makefile.inc so that CMake/CPack is aware of what's to include).
# Add CTests(?)
# Check on all possible platforms
# Test with as many configurations possible (With or without any option)
# Create scripts that help keeping the CMake build system up to date (to reduce maintenance). According to Tetetest:
#  - lists of headers that 'configure' checks for;
#  - curl-specific tests (the ones that are in m4/curl-*.m4 files);
#  - (most obvious thing:) curl version numbers.
# Add documentation subproject
#
# To check:
# (From Daniel Stenberg) The cmake build selected to run gcc with -fPIC on my box while the plain configure script did not.
# (From Daniel Stenberg) The gcc command line use neither -g nor any -O options. As a developer, I also treasure our configure scripts's --enable-debug option that sets a long range of "picky" compiler options.
cmake_minimum_required(VERSION 2.6.2 FATAL_ERROR)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake;${CMAKE_MODULE_PATH}")
include(Utilities)

project( CURL C )

file (READ ${CURL_SOURCE_DIR}/include/curl/curlver.h CURL_VERSION_H_CONTENTS)
string (REGEX MATCH "LIBCURL_VERSION_MAJOR[ \t]+([0-9]+)"
  LIBCURL_VERSION_MJ ${CURL_VERSION_H_CONTENTS})
string (REGEX MATCH "([0-9]+)"
  LIBCURL_VERSION_MJ ${LIBCURL_VERSION_MJ})
string (REGEX MATCH
  "LIBCURL_VERSION_MINOR[ \t]+([0-9]+)"
  LIBCURL_VERSION_MI ${CURL_VERSION_H_CONTENTS})
string (REGEX MATCH "([0-9]+)" LIBCURL_VERSION_MI ${LIBCURL_VERSION_MI})
string (REGEX MATCH
  "LIBCURL_VERSION_PATCH[ \t]+([0-9]+)"
  LIBCURL_VERSION_PT ${CURL_VERSION_H_CONTENTS})
string (REGEX MATCH "([0-9]+)" LIBCURL_VERSION_PT ${LIBCURL_VERSION_PT})
set (CURL_MAJOR_VERSION ${LIBCURL_VERSION_MJ})
set (CURL_MINOR_VERSION ${LIBCURL_VERSION_MI})
set (CURL_PATCH_VERSION ${LIBCURL_VERSION_PT})

include_regular_expression("^.*$")    # Sukender: Is it necessary?

# Setup package meta-data
# SET(PACKAGE "curl")
set(CURL_VERSION ${CURL_MAJOR_VERSION}.${CURL_MINOR_VERSION}.${CURL_PATCH_VERSION})
message(STATUS "curl version=[${CURL_VERSION}]")
# SET(PACKAGE_TARNAME "curl")
# SET(PACKAGE_NAME "curl")
# SET(PACKAGE_VERSION "-")
# SET(PACKAGE_STRING "curl-")
# SET(PACKAGE_BUGREPORT "a suitable curl mailing list => http://curl.haxx.se/mail/")
set(OPERATING_SYSTEM "${CMAKE_SYSTEM_NAME}")
set(OS "\"${CMAKE_SYSTEM_NAME}\"")

include_directories(${PROJECT_BINARY_DIR}/include/curl)
include_directories( ${CURL_SOURCE_DIR}/include )

if(WIN32)
  set(NATIVE_WINDOWS ON)
endif()

option(BUILD_CURL_EXE "Set to ON to build cURL executable." ON)
option(BUILD_CURL_TESTS "Set to ON to build cURL tests." ON)
option(CURL_STATICLIB "Set to ON to build libcurl with static linking." OFF)
option(CURL_USE_ARES "Set to ON to enable c-ares support" OFF)
# initialize CURL_LIBS
set(CURL_LIBS "")

if(CURL_USE_ARES)
  set(USE_ARES ${CURL_USE_ARES})
  find_package(CARES REQUIRED)
  list(APPEND CURL_LIBS ${CARES_LIBRARY} )
  set(CURL_LIBS ${CURL_LIBS} ${CARES_LIBRARY})
endif()

option(BUILD_DASHBOARD_REPORTS "Set to ON to activate reporting of cURL builds here http://www.cdash.org/CDashPublic/index.php?project=CURL" OFF)
if(BUILD_DASHBOARD_REPORTS)
  #INCLUDE(Dart)
  include(CTest)
endif(BUILD_DASHBOARD_REPORTS)

if(MSVC)
  option(BUILD_RELEASE_DEBUG_DIRS "Set OFF to build each configuration to a separate directory" OFF)
  mark_as_advanced(BUILD_RELEASE_DEBUG_DIRS)
endif()

option(CURL_HIDDEN_SYMBOLS "Set to ON to hide libcurl internal symbols (=hide all symbols that aren't officially external)." ON)
mark_as_advanced(CURL_HIDDEN_SYMBOLS)

# IF(WIN32)
# OPTION(CURL_WINDOWS_SSPI "Use windows libraries to allow NTLM authentication without openssl" ON)
# MARK_AS_ADVANCED(CURL_WINDOWS_SSPI)
# ENDIF()

option(HTTP_ONLY "disables all protocols except HTTP (This overrides all CURL_DISABLE_* options)" OFF)
mark_as_advanced(HTTP_ONLY)
option(CURL_DISABLE_FTP "disables FTP" OFF)
mark_as_advanced(CURL_DISABLE_FTP)
option(CURL_DISABLE_LDAP "disables LDAP" OFF)
mark_as_advanced(CURL_DISABLE_LDAP)
option(CURL_DISABLE_TELNET "disables Telnet" OFF)
mark_as_advanced(CURL_DISABLE_TELNET)
option(CURL_DISABLE_DICT "disables DICT" OFF)
mark_as_advanced(CURL_DISABLE_DICT)
option(CURL_DISABLE_FILE "disables FILE" OFF)
mark_as_advanced(CURL_DISABLE_FILE)
option(CURL_DISABLE_TFTP "disables TFTP" OFF)
mark_as_advanced(CURL_DISABLE_TFTP)
option(CURL_DISABLE_HTTP "disables HTTP" OFF)
mark_as_advanced(CURL_DISABLE_HTTP)

option(CURL_DISABLE_LDAPS "to disable LDAPS" OFF)
mark_as_advanced(CURL_DISABLE_LDAPS)
if(WIN32)
  set(CURL_DEFAULT_DISABLE_LDAP OFF)
  # some windows compilers do not have wldap32
  if( NOT HAVE_WLDAP32)
    set(CURL_DISABLE_LDAP ON CACHE BOOL "" FORCE)
    message(STATUS "wldap32 not found CURL_DISABLE_LDAP set ON")
    option(CURL_LDAP_WIN "Use Windows LDAP implementation" OFF)
  else()
    option(CURL_LDAP_WIN "Use Windows LDAP implementation" ON)
  endif()
  mark_as_advanced(CURL_LDAP_WIN)
endif()

if(HTTP_ONLY)
  set(CURL_DISABLE_FTP ON)
  set(CURL_DISABLE_LDAP ON)
  set(CURL_DISABLE_TELNET ON)
  set(CURL_DISABLE_DICT ON)
  set(CURL_DISABLE_FILE ON)
  set(CURL_DISABLE_TFTP ON)
endif()

option(CURL_DISABLE_COOKIES "to disable cookies support" OFF)
mark_as_advanced(CURL_DISABLE_COOKIES)

option(CURL_DISABLE_CRYPTO_AUTH "to disable cryptographic authentication" OFF)
mark_as_advanced(CURL_DISABLE_CRYPTO_AUTH)
option(CURL_DISABLE_VERBOSE_STRINGS "to disable verbose strings" OFF)
mark_as_advanced(CURL_DISABLE_VERBOSE_STRINGS)
option(DISABLED_THREADSAFE "Set to explicitly specify we don't want to use thread-safe functions" OFF)
mark_as_advanced(DISABLED_THREADSAFE)
option(ENABLE_IPV6 "Define if you want to enable IPv6 support" OFF)
mark_as_advanced(ENABLE_IPV6)

if(WIN32)
  # Windows standard libraries are located in C:/Program Files/Microsoft SDKs/[...]
  # They are already included in the default MSVC LIBPATH => no find_library is needed!
  list_spaces_append_once(CMAKE_C_STANDARD_LIBRARIES wsock32.lib ws2_32.lib)  # bufferoverflowu.lib
  if(CURL_DISABLE_LDAP)
    # Remove wldap32.lib from space-separated list
    string(REPLACE " " ";" _LIST ${CMAKE_C_STANDARD_LIBRARIES})
    list(REMOVE_ITEM _LIST "wldap32.lib")
    to_list_spaces(_LIST CMAKE_C_STANDARD_LIBRARIES)
  else()
    # Append wldap32.lib
    list_spaces_append_once(CMAKE_C_STANDARD_LIBRARIES wldap32.lib)
  endif()
  set(CMAKE_C_STANDARD_LIBRARIES "${CMAKE_C_STANDARD_LIBRARIES}"   CACHE STRING "" FORCE)
endif()


# We need ansi c-flags, especially on HP
set(CMAKE_C_FLAGS "${CMAKE_ANSI_CFLAGS} ${CMAKE_C_FLAGS}")
set(CMAKE_REQUIRED_FLAGS ${CMAKE_ANSI_CFLAGS})

# Disable warnings on Borland to avoid changing 3rd party code.
if(BORLAND)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -w-")
endif(BORLAND)

# If we are on AIX, do the _ALL_SOURCE magic
if(${CMAKE_SYSTEM_NAME} MATCHES AIX)
  set(_ALL_SOURCE 1)
endif(${CMAKE_SYSTEM_NAME} MATCHES AIX)

# Include all the necessary files for macros
include (CheckFunctionExists)
include (CheckIncludeFile)
include (CheckIncludeFiles)
include (CheckLibraryExists)
include (CheckSymbolExists)
include (CheckTypeSize)

# On windows preload settings
if(WIN32)
  include(${CMAKE_CURRENT_SOURCE_DIR}/CMake/Platforms/WindowsCache.cmake)
endif(WIN32)

# This macro checks if the symbol exists in the library and if it
# does, it prepends library to the list.
macro(CHECK_LIBRARY_EXISTS_CONCAT LIBRARY SYMBOL VARIABLE)
  check_library_exists("${LIBRARY};${CURL_LIBS}" ${SYMBOL} "${CMAKE_LIBRARY_PATH}"
    ${VARIABLE})
  if(${VARIABLE})
    set(CURL_LIBS ${LIBRARY} ${CURL_LIBS})
  endif(${VARIABLE})
endmacro(CHECK_LIBRARY_EXISTS_CONCAT)

# Check for all needed libraries
check_library_exists_concat("dl"     dlopen       HAVE_LIBDL)
check_library_exists_concat("socket" connect      HAVE_LIBSOCKET)
check_library_exists("c" gethostbyname "" NOT_NEED_LIBNSL)

# Yellowtab Zeta needs different libraries than BeOS 5.
if(BEOS)
  set(NOT_NEED_LIBNSL 1)
  check_library_exists_concat("bind" gethostbyname HAVE_LIBBIND)
  check_library_exists_concat("bnetapi" closesocket HAVE_LIBBNETAPI)
endif(BEOS)

if(NOT NOT_NEED_LIBNSL)
  check_library_exists_concat("nsl"    gethostbyname  HAVE_LIBNSL)
endif(NOT NOT_NEED_LIBNSL)

check_library_exists_concat("ws2_32" getch        HAVE_LIBWS2_32)
check_library_exists_concat("winmm"  getch        HAVE_LIBWINMM)
check_library_exists("wldap32" cldap_open "" HAVE_WLDAP32)

# IF(NOT CURL_SPECIAL_LIBZ)
#  CHECK_LIBRARY_EXISTS_CONCAT("z"      inflateEnd   HAVE_LIBZ)
# ENDIF(NOT CURL_SPECIAL_LIBZ)

# Check for idn
check_library_exists_concat("idn" idna_to_ascii_lz HAVE_LIBIDN)

# Check for LDAP
check_library_exists_concat("ldap" ldap_init HAVE_LIBLDAP)
# if(NOT HAVE_LIBLDAP)
# SET(CURL_DISABLE_LDAP ON)
# endif(NOT HAVE_LIBLDAP)

# Check for symbol dlopen (same as HAVE_LIBDL)
check_library_exists("${CURL_LIBS}" dlopen "" HAVE_DLOPEN)

# For other tests to use the same libraries
set(CMAKE_REQUIRED_LIBRARIES ${CURL_LIBS})

option(CURL_ZLIB "Set to ON to enable building cURL with zlib support." ON)
set(HAVE_LIBZ OFF)
set(HAVE_ZLIB_H OFF)
set(HAVE_ZLIB OFF)
if(CURL_ZLIB)  # AND CURL_CONFIG_HAS_BEEN_RUN_BEFORE
  find_package(ZLIB QUIET)
  if(ZLIB_FOUND)
    set(HAVE_ZLIB_H ON)
    set(HAVE_ZLIB ON)
    set(HAVE_LIBZ ON)
  endif()
endif()

option(CMAKE_USE_OPENSSL "Use OpenSSL code. Experimental" ON)
mark_as_advanced(CMAKE_USE_OPENSSL)
if(CMAKE_USE_OPENSSL)
  if(WIN32)
    find_package(OpenSSL)
    if(OPENSSL_FOUND)
      set(USE_SSLEAY TRUE)
      set(USE_OPENSSL TRUE)
      list(APPEND CURL_LIBS ${OPENSSL_LIBRARIES} )
    else()
      set(CMAKE_USE_OPENSSL FALSE)
      message(STATUS "OpenSSL NOT Found, disabling CMAKE_USE_OPENSSL")
    endif()
  else(WIN32)
    check_library_exists_concat("crypto" CRYPTO_lock  HAVE_LIBCRYPTO)
    check_library_exists_concat("ssl"    SSL_connect  HAVE_LIBSSL)
  endif(WIN32)
endif(CMAKE_USE_OPENSSL)

# If we have features.h, then do the _BSD_SOURCE magic
check_include_file("features.h"       HAVE_FEATURES_H)

# Check if header file exists and add it to the list.
macro(CHECK_INCLUDE_FILE_CONCAT FILE VARIABLE)
  check_include_files("${CURL_INCLUDES};${FILE}" ${VARIABLE})
  if(${VARIABLE})
    set(CURL_INCLUDES ${CURL_INCLUDES} ${FILE})
    set(CURL_TEST_DEFINES "${CURL_TEST_DEFINES} -D${VARIABLE}")
  endif(${VARIABLE})
endmacro(CHECK_INCLUDE_FILE_CONCAT)


# Check for header files
if(NOT UNIX)
  check_include_file_concat("ws2tcpip.h"     HAVE_WS2TCPIP_H)
  check_include_file_concat("winsock2.h"     HAVE_WINSOCK2_H)
endif(NOT UNIX)
check_include_file_concat("stdio.h"          HAVE_STDIO_H)
if(NOT UNIX)
  check_include_file_concat("windows.h"      HAVE_WINDOWS_H)
  check_include_file_concat("winsock.h"      HAVE_WINSOCK_H)
endif(NOT UNIX)

check_include_file_concat("inttypes.h"       HAVE_INTTYPES_H)
check_include_file_concat("sys/filio.h"      HAVE_SYS_FILIO_H)
check_include_file_concat("sys/ioctl.h"      HAVE_SYS_IOCTL_H)
check_include_file_concat("sys/param.h"      HAVE_SYS_PARAM_H)
check_include_file_concat("sys/poll.h"       HAVE_SYS_POLL_H)
check_include_file_concat("sys/resource.h"   HAVE_SYS_RESOURCE_H)
check_include_file_concat("sys/select.h"     HAVE_SYS_SELECT_H)
check_include_file_concat("sys/socket.h"     HAVE_SYS_SOCKET_H)
check_include_file_concat("sys/sockio.h"     HAVE_SYS_SOCKIO_H)
check_include_file_concat("sys/stat.h"       HAVE_SYS_STAT_H)
check_include_file_concat("sys/time.h"       HAVE_SYS_TIME_H)
check_include_file_concat("sys/types.h"      HAVE_SYS_TYPES_H)
check_include_file_concat("sys/uio.h"        HAVE_SYS_UIO_H)
check_include_file_concat("sys/un.h"         HAVE_SYS_UN_H)
check_include_file_concat("sys/utime.h"      HAVE_SYS_UTIME_H)
check_include_file_concat("alloca.h"         HAVE_ALLOCA_H)

=== debian/changelog ===
curl (7.25.0-1maemo3) fremantle; urgency=low
  * Fix missing dependency for libcurl4-openssl-dev (librtmp-dev)

 -- Ludek Finstrle <luf@pzkagis.cz>  Wed, 09 May 2012 11:37:29 +0200

curl (7.25.0-1maemo2) fremantle; urgency=low
  * Maemo package cleanup

 -- Ludek Finstrle <luf@pzkagis.cz>  Fri, 30 Mar 2012 10:07:43 +0200

curl (7.25.0-1maemo1) fremantle; urgency=high
  * New upstream release
    - Fix builds with proxy or http disabled
    - Fix a numeric overflow in parsing date
    - COOKIES: strip the numerical ipv6 host properly
    - Fix CONNECT: fix multi interface regression
      http://curl.haxx.se/mail/lib-2012-03/0162.html
    - SWS: refuse to serve CONNECT unless running as proxy
    - Update detection logic of getaddrinfo() thread-safeness
    - Fix --libcurl option output file text translation mode
    - Fix OOM handling
    - Fix resolve with c-ares: don't resolve IPv6 when not working
      http://curl.haxx.se/mail/lib-2012-03/0045.html
    - SMTP: Changed the curl error code for EHLO and HELO responses

 -- Ludek Finstrle <luf@pzkagis.cz>  Fri, 23 Mar 2012 09:29:36 +0100

=== debian/control ===
Source: curl
Section: web
Priority: optional
Maintainer: Ludek Finstrle <luf@pzkagis.cz>
XSBC-Original-Maintainer: Ramakrishnan Muthukrishnan <rkrishnan@debian.org>
Build-Depends: debhelper (>> 5.0.41),
 autoconf,
 automake1.9,
 groff-base,
 libgcrypt11-dev,
 libidn11-dev,
 libkrb5-dev,
 libssl-dev,
 libtool,
 quilt,
 stunnel4,
 zlib1g-dev
Build-Conflicts: autoconf2.13, automake1.4
Standards-Version: 3.9.2

Package: curl
Architecture: any
Replaces: curl-ssl
Provides: curl-ssl
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: command line tool for transferring data with URL syntax
 curl is a command line tool for transferring data with URL syntax, supporting
 DICT, FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, POP3, POP3S, SCP,
 SFTP, SMTP, SMTPS, TELNET and TFTP.
 .
 curl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP form
 based upload, proxies, cookies, user+password authentication (Basic, Digest,
 NTLM, Negotiate, kerberos...), file transfer resume, proxy tunneling and a
 busload of other useful tricks.

Package: libcurl3
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: ca-certificates
Replaces: libcurl2 (<< 1:7.11.2-2), libcurl4
Conflicts: libcurl4
Pre-Depends: ${misc:Pre-Depends}
Description: easy-to-use client-side URL transfer library (OpenSSL flavour)
 libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
 FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, POP3, POP3S, SCP, SFTP,
 SMTP, SMTPS, TELNET and TFTP.
 .
 libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
 form based upload, proxies, cookies, user+password authentication (Basic,
 Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
 and more!
 .
 libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
 fast, thoroughly documented and is already used by many known, big and
 successful companies and numerous applications.
 .
 SSL support is provided by OpenSSL.

Package: libcurl4-openssl-dev
Architecture: any
Section: libdevel
Suggests: libcurl3-dbg
Provides: libcurl-dev,
 libcurl-ssl-dev,
 libcurl3-openssl-dev,
 libcurl4-dev,
 libcurl3-dev
Replaces: libcurl-dev,
 libcurl-ssl-dev,
 libcurl3-openssl-dev,
 libcurl3-dev (<< 7.14.1-1)
Conflicts: libcurl-dev
Depends: ${misc:Depends}, libcurl3 (= ${binary:Version}),
 libc6-dev | libc-dev,
 libidn11-dev,
 libkrb5-dev,
 libssl-dev,
 zlib1g-dev
Description: development files and documentation for libcurl (OpenSSL flavour)
 libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
 FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, POP3, POP3S, SCP, SFTP,
 SMTP, SMTPS, TELNET and TFTP.
 .
 libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
 form based upload, proxies, cookies, user+password authentication (Basic,
 Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
 and more!
 .
 libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
 fast, thoroughly documented and is already used by many known, big and
 successful companies and numerous applications.
 .
 This package provides the development files (ie. includes, static library,
 manual pages) that allow to build software which uses libcurl. HTML and PDF
 versions of all the manual pages are also provided.
 .
 SSL support is provided by OpenSSL.

Package: libcurl3-dev
Architecture: all
Section: libdevel
Provides: libcurl-dev, libcurl-ssl-dev
Replaces: libcurl-dev, libcurl-ssl-dev
Depends: libcurl4-openssl-dev (= ${binary:Version})
Description: Transitional package to libcurl4-openssl-dev
 Transitional package depending on libcurl4-openssl-dev.
 .
 Once installed, this package may be safely removed.
 .
  Homepage: http://curl.haxx.se

Package: libcurl3-dbg
Architecture: any
Section: debug
Priority: extra
Suggests: libc-dbg
Provides: libcurl4-dbg
Replaces: libcurl4-dbg
Conflicts: libcurl4-dbg
Depends: ${misc:Depends}, libcurl3 (= ${binary:Version}) | libcurl3-gnutls (= ${binary:Version}) | libcurl3-nss (= ${binary:Version})
Description: debugging symbols for libcurl (OpenSSL, GnuTLS and NSS flavours)
 libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
 FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, POP3, POP3S, SCP, SFTP,
 SMTP, SMTPS, TELNET and TFTP.
 .
 libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
 form based upload, proxies, cookies, user+password authentication (Basic,
 Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
 and more!
 .
 libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
 fast, thoroughly documented and is already used by many known, big and
 successful companies and numerous applications.
 .
 This package provides the debugging symbols of the OpenSSL, GnuTLS and NSS
 versions of libcurl3. It might be useful in debug sessions of software which
 uses libcurl.

=== debian/rules ===
#! /usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# These are locations of quilt stuff
export QUILT_PATCHES=$(shell pwd)/debian/patches

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_BUILD_ARCH_OS ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

# set the number of build jobs
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    JOBS:=-j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE) --with-random=/dev/urandom
else
CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif

# Maemo specific
DO_TEST=no
SHLIBS_VERSION=7.16.2-1

# this will catch miss-linking. (e.g. undefined symbols)
# LDFLAGS = -Wl,-z,defs

CONFIGURE_ARGS = $(CROSS) --prefix=/usr --mandir=/usr/share/man	\
		--disable-dependency-tracking --enable-ipv6	\
		--with-lber-lib=lber --enable-manual		\
		--enable-versioned-symbols --enable-debug	\
		--libdir=\$${prefix}/lib	\
		$(shell dpkg-buildflags --export=configure)
# this is still not ready
# --enable-ares
# this fixes the ldap warning of dpkg-shlibdebs, but we dont want that.
# --with-ldap-lib=/usr/lib/libldap_r.so

ifneq (${DEB_BUILD_ARCH_OS},hurd)
CONFIGURE_ARGS += --with-gssapi=/usr
endif

build-arch: build-stamp
build-indep: build-stamp

build: build-arch build-indep
#configure-stamp: DH_OPTIONS=
configure-stamp:
	dh_testdir
	mkdir -p debian/build
	-quilt push -a
	# pop the last patch (nss)
	quilt pop
	# pop the second last patch (gnutls)
	quilt pop

	# get the source without nss and gnutls patches
	tar -cf - --exclude=debian --exclude=.pc . | tar -xf - -C debian/build
	for flavour in build; do \
		(cd debian/$$flavour && ./buildconf) \
	done
	cd debian/build && ./configure ${CONFIGURE_ARGS}		\
		--with-ca-path=/etc/ssl/certs
	touch configure-stamp

#build-stamp: DH_OPTIONS=
build-stamp: configure-stamp
	dh_testdir
	${MAKE} $(JOBS) -C debian/build
ifeq (${DO_TEST},yes)
	-${MAKE} -C debian/build test
endif
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	-quilt pop -a
	rm -rf build-stamp configure-stamp debian/build 
	dh_clean debian/shlibs.local debian/libcurl3.links

#install: DH_OPTIONS=
install: build-stamp
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	for file in libcurl3.links; \
	do \
		sed -e"s,/\$${DEB_HOST_MULTIARCH},,g" \
			debian/$${file}.in > debian/$$file; \
	done
	${MAKE} -C debian/build DESTDIR=$(shell pwd)/debian/tmp install
	dh_install --sourcedir=debian/tmp
	install -D -m 644 debian/libcurl3.lintian-overrides debian/libcurl3/usr/share/lintian/overrides/libcurl3
	for i in `find debian/lib* -name "lib*.la"`; do echo "removing dependency_libs from $$i"; sed -i -e "/dependency_libs/ s/'.*'/''/" $$i; done

# Build architecture-independent files here.
#binary-indep: DH_OPTIONS=-i
binary-indep: build-stamp install
# We have nothing to do here.

# Build architecture-dependent files here.
#binary-arch: DH_OPTIONS=-a
binary-arch: build-stamp install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installman
	dh_installexamples
	dh_installchangelogs CHANGES
	dh_link
	dh_strip -Nlibcurl3
	dh_strip -plibcurl3 --dbg-package=libcurl3-dbg
	dh_compress
	dh_fixperms
	echo "libcurl 4 libcurl3 (>= $(SHLIBS_VERSION))" > debian/shlibs.local
	dh_makeshlibs -plibcurl3 -V "libcurl3 (>= $(SHLIBS_VERSION))"
	dh_installdeb
	dh_shlibdeps
	dh_md5sums
	dh_gencontrol
	dh_builddeb

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep build clean install

## curl 7.26.0

=== debian/changelog ===
curl (7.26.0-1+wheezy9) wheezy-security; urgency=high

  * Fix multiple security issues (Closes: #742728):
    - Fix connection re-use when using different log-in credentials
      as per CVE-2014-0138
      http://curl.haxx.se/docs/adv_20140326A.html
    - Reject IP address wildcard matches as per CVE-2014-0139
      http://curl.haxx.se/docs/adv_20140326B.html
  * Set urgency=high accordingly

 -- Alessandro Ghedini <ghedo@debian.org>  Wed, 09 Apr 2014 19:03:55 +0200

curl (7.26.0-1+wheezy8) wheezy-security; urgency=high

  * Fix re-use of wrong HTTP NTLM connection as per CVE-2014-0015
    http://curl.haxx.se/docs/adv_20140129.html
  * Set urgency=high accordingly

 -- Alessandro Ghedini <ghedo@debian.org>  Wed, 29 Jan 2014 19:01:03 +0100

curl (7.26.0-1+wheezy7) stable-security; urgency=high

  * Fix GnuTLS checking of a certificate CN or SAN name field when the digital
    signature verification is turned off as per CVE-2013-6422
    http://curl.haxx.se/docs/adv_20131217.html
  * Set urgency=high accordingly

 -- Alessandro Ghedini <ghedo@debian.org>  Wed, 11 Dec 2013 18:00:59 +0100

curl (7.26.0-1+wheezy6) stable-security; urgency=low

  * Disable host verification too when using the --insecure option
    (Closes: #729965)

 -- Alessandro Ghedini <ghedo@debian.org>  Tue, 19 Nov 2013 17:15:32 +0100

curl (7.26.0-1+wheezy5) stable-security; urgency=high

  * Fix OpenSSL checking of a certificate CN or SAN name field when the
    digital signature verification is turned off as per CVE-2013-4545
    http://curl.haxx.se/docs/adv_20131115.html
  * Set urgency=high accordingly

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 16 Nov 2013 13:04:23 +0100

curl (7.26.0-1+wheezy4) stable-proposed-updates; urgency=low

  * Add 09_reset-timecond.patch (Closes: #705783, #719300)

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 10 Aug 2013 16:45:38 +0200

curl (7.26.0-1+wheezy3) stable-security; urgency=high

  * Fix URL decode buffer boundary flaw as per CVE-2013-2174
    http://curl.haxx.se/docs/adv_20130622.html
  * Set urgency=high accordingly

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 22 Jun 2013 16:45:24 +0200

curl (7.26.0-1+wheezy2) wheezy-proposed-updates; urgency=high

  [ Alessandro Ghedini ]
  * Fix cookie domain tailmatch as per CVE-2013-1944
    http://curl.haxx.se/docs/adv_20130412.html (Closes: #705274)
  * Set urgency=high accordingly

  [ Salvatore Bonaccorso ]
  * Add testcase for CVE-2013-1944

 -- Alessandro Ghedini <ghedo@debian.org>  Wed, 10 Apr 2013 22:56:48 +0200

curl (7.26.0-1+wheezy1) testing-proposed-updates; urgency=high

  * Fix buffer overflow when negotiating SMTP DIGEST-MD5 authentication
    as per CVE-2013-0249 (Closes: #700002)
    http://curl.haxx.se/docs/adv_20130206.html
  * Set urgency=high accordingly

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 10 Feb 2013 19:14:47 +0100

curl (7.26.0-1) unstable; urgency=low

  * New upstream release
    - Reject numerical IPv6 addresses outside brackets (Closes: #670126)
  * Email change: Alessandro Ghedini -> ghedo@debian.org
  * Stricter Depends on libcurl3 (Closes: #666089)
  * Remove Ramakrishnan (as per his request), move myself to Maintainer
    Thank you for all your work so far
  * Disable memory tracking, but keep debug enabled
    - Remove memdebug symbols (used by curl only)
  * Refresh 01_runtests_gdb.patch, 90_gnutls.patch and 99_nss.patch
  * Disable not-quite-working symbols hiding

 -- Alessandro Ghedini <ghedo@debian.org>  Fri, 25 May 2012 15:19:51 +0200

curl (7.25.0-1) unstable; urgency=low

  * New upstream release
    - Add --ssl-allow-beast and CURLOPT_SSL_OPTIONS (Closes: #658276)
    - Allow negative numbers as option value (Closes: #659591)
  * Add libssh2-1-dev to libcurl4-gnutls-dev and libcurl4-nss-dev Depends
  * Bump debhelper compat level to 9
    - Make *.links files executable to simplify rules file
  * Pass --as-needed ld flag to avoid unneeded dependencies
    - Add workaround_as_needed_bug to workaround a libtool bug
    - Drop dont_link_to_krb5 (not needed because of --as-needed)
  * Do some clean-up in debian/rules
  * Update debian/copyright format as in Debian Policy 3.9.3
  * Bump Standards-Version to 3.9.3
  * Explicit Conflicts in -dev packages (fixes binaries-have-file-conflict)
  * Add openssh-server to build depends to enable some more tests
  * Update upstream copyright years
  * Refresh patches

 -- Alessandro Ghedini <al3xbio@gmail.com>  Fri, 23 Mar 2012 16:24:51 +0100

=== debian/control ===
--- 
+++ 
@@ -1,32 +1,43 @@
 Source: curl
 Section: web
 Priority: optional
-Maintainer: Ludek Finstrle <luf@pzkagis.cz>
-XSBC-Original-Maintainer: Ramakrishnan Muthukrishnan <rkrishnan@debian.org>
-Build-Depends: debhelper (>> 5.0.41),
+Maintainer: Alessandro Ghedini <ghedo@debian.org>
+Uploaders: Ian Jackson <ijackson@chiark.greenend.org.uk>,
+ Luk Claes <luk@debian.org>
+Build-Depends: debhelper (>= 9),
  autoconf,
  automake1.9,
  groff-base,
  libgcrypt11-dev,
- libidn11-dev,
- libkrb5-dev,
+ libgnutls-dev,
+ libidn11-dev,
+ libkrb5-dev,
+ libldap2-dev,
+ libnss3-dev,
+ librtmp-dev,
+ libssh2-1-dev (>= 1.2),
  libssl-dev,
  libtool,
+ openssh-server,
  quilt,
  stunnel4,
  zlib1g-dev
 Build-Conflicts: autoconf2.13, automake1.4
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
+Vcs-Browser: http://git.debian.org/?p=collab-maint/curl.git
+Vcs-Git: git://git.debian.org/collab-maint/curl.git
+Homepage: http://curl.haxx.se
 
 Package: curl
 Architecture: any
 Replaces: curl-ssl
 Provides: curl-ssl
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends},
+ libcurl3 (= ${binary:Version})
 Description: command line tool for transferring data with URL syntax
  curl is a command line tool for transferring data with URL syntax, supporting
- DICT, FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, POP3, POP3S, SCP,
- SFTP, SMTP, SMTPS, TELNET and TFTP.
+ DICT, FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, POP3, POP3S,
+ RTMP, RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
  .
  curl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP form
  based upload, proxies, cookies, user+password authentication (Basic, Digest,
@@ -41,10 +52,11 @@
 Replaces: libcurl2 (<< 1:7.11.2-2), libcurl4
 Conflicts: libcurl4
 Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: same
 Description: easy-to-use client-side URL transfer library (OpenSSL flavour)
  libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
- FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, POP3, POP3S, SCP, SFTP,
- SMTP, SMTPS, TELNET and TFTP.
+ FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, POP3, POP3S, RTMP,
+ RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
  .
  libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
  form based upload, proxies, cookies, user+password authentication (Basic,
@@ -56,6 +68,56 @@
  successful companies and numerous applications.
  .
  SSL support is provided by OpenSSL.
+
+Package: libcurl3-gnutls
+Architecture: any
+Section: libs
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Recommends: ca-certificates
+Replaces: libcurl4-gnutls
+Conflicts: libcurl4-gnutls
+Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: same
+Description: easy-to-use client-side URL transfer library (GnuTLS flavour)
+ libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
+ FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, POP3, POP3S, RTMP,
+ RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
+ .
+ libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
+ form based upload, proxies, cookies, user+password authentication (Basic,
+ Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
+ and more!
+ .
+ libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
+ fast, thoroughly documented and is already used by many known, big and
+ successful companies and numerous applications.
+ .
+ SSL support is provided by GnuTLS.
+
+Package: libcurl3-nss
+Architecture: any
+Section: libs
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Recommends: ca-certificates
+Replaces: libcurl4-nss
+Conflicts: libcurl4-nss
+Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: same
+Description: easy-to-use client-side URL transfer library (NSS flavour)
+ libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
+ FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, POP3, POP3S, RTMP,
+ RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
+ .
+ libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
+ form based upload, proxies, cookies, user+password authentication (Basic,
+ Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
+ and more!
+ .
+ libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
+ fast, thoroughly documented and is already used by many known, big and
+ successful companies and numerous applications.
+ .
+ SSL support is provided by NSS.
 
 Package: libcurl4-openssl-dev
 Architecture: any
@@ -70,17 +132,22 @@
  libcurl-ssl-dev,
  libcurl3-openssl-dev,
  libcurl3-dev (<< 7.14.1-1)
-Conflicts: libcurl-dev
+Conflicts: libcurl-dev,
+ libcurl4-gnutls-dev,
+ libcurl4-nss-dev
 Depends: ${misc:Depends}, libcurl3 (= ${binary:Version}),
  libc6-dev | libc-dev,
  libidn11-dev,
  libkrb5-dev,
+ libldap2-dev,
+ librtmp-dev,
+ libssh2-1-dev,
  libssl-dev,
  zlib1g-dev
 Description: development files and documentation for libcurl (OpenSSL flavour)
  libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
- FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, POP3, POP3S, SCP, SFTP,
- SMTP, SMTPS, TELNET and TFTP.
+ FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, POP3, POP3S, RTMP,
+ RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
  .
  libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
  form based upload, proxies, cookies, user+password authentication (Basic,
@@ -97,18 +164,93 @@
  .
  SSL support is provided by OpenSSL.
 
-Package: libcurl3-dev
-Architecture: all
+Package: libcurl4-gnutls-dev
+Architecture: any
 Section: libdevel
-Provides: libcurl-dev, libcurl-ssl-dev
-Replaces: libcurl-dev, libcurl-ssl-dev
-Depends: libcurl4-openssl-dev (= ${binary:Version})
-Description: Transitional package to libcurl4-openssl-dev
- Transitional package depending on libcurl4-openssl-dev.
- .
- Once installed, this package may be safely removed.
- .
-  Homepage: http://curl.haxx.se
+Suggests: libcurl3-dbg
+Provides: libcurl-dev,
+ libcurl-ssl-dev,
+ libcurl3-gnutls-dev,
+ libcurl4-dev
+Replaces: libcurl-dev,
+ libcurl-ssl-dev,
+ libcurl3-gnutls-dev,
+ libcurl4-dev
+Conflicts: libcurl-dev,
+ libcurl4-openssl-dev,
+ libcurl4-nss-dev
+Depends: ${misc:Depends}, libcurl3-gnutls (= ${binary:Version}),
+ libc6-dev | libc-dev,
+ libgnutls-dev,
+ libidn11-dev,
+ libkrb5-dev,
+ libldap2-dev,
+ librtmp-dev,
+ libssh2-1-dev,
+ zlib1g-dev
+Description: development files and documentation for libcurl (GnuTLS flavour)
+ libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
+ FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, POP3, POP3S, RTMP,
+ RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
+ .
+ libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
+ form based upload, proxies, cookies, user+password authentication (Basic,
+ Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
+ and more!
+ .
+ libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
+ fast, thoroughly documented and is already used by many known, big and
+ successful companies and numerous applications.
+ .
+ This package provides the development files (ie. includes, static library,
+ manual pages) that allow to build software which uses libcurl. HTML and PDF
+ versions of all the manual pages are also provided.
+ .
+ SSL support is provided by GnuTLS.
+
+Package: libcurl4-nss-dev
+Architecture: any
+Section: libdevel
+Suggests: libcurl3-dbg
+Provides: libcurl-dev,
+ libcurl-ssl-dev,
+ libcurl3-nss-dev,
+ libcurl4-dev
+Replaces: libcurl-dev,
+ libcurl-ssl-dev,
+ libcurl3-nss-dev,
+ libcurl4-dev
+Conflicts: libcurl-dev,
+ libcurl4-openssl-dev,
+ libcurl4-gnutls-dev
+Depends: ${misc:Depends}, libcurl3-nss (= ${binary:Version}),
+ libc6-dev | libc-dev,
+ libidn11-dev,
+ libkrb5-dev,
+ libldap2-dev,
+ libnss3-dev,
+ librtmp-dev,
+ libssh2-1-dev,
+ zlib1g-dev
+Description: development files and documentation for libcurl (NSS flavour)
+ libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
+ FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, POP3, POP3S, RTMP,
+ RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
+ .
+ libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
+ form based upload, proxies, cookies, user+password authentication (Basic,
+ Digest, NTLM, Negotiate, Kerberos), file transfer resume, http proxy tunneling
+ and more!
+ .
+ libcurl is free, thread-safe, IPv6 compatible, feature rich, well supported,
+ fast, thoroughly documented and is already used by many known, big and
+ successful companies and numerous applications.
+ .
+ This package provides the development files (ie. includes, static library,
+ manual pages) that allow to build software which uses libcurl. HTML and PDF
+ versions of all the manual pages are also provided.
+ .
+ SSL support is provided by NSS.
 
 Package: libcurl3-dbg
 Architecture: any
@@ -119,10 +261,11 @@
 Replaces: libcurl4-dbg
 Conflicts: libcurl4-dbg
 Depends: ${misc:Depends}, libcurl3 (= ${binary:Version}) | libcurl3-gnutls (= ${binary:Version}) | libcurl3-nss (= ${binary:Version})
+Multi-Arch: same
 Description: debugging symbols for libcurl (OpenSSL, GnuTLS and NSS flavours)
  libcurl is an easy-to-use client-side URL transfer library, supporting DICT,
- FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, POP3, POP3S, SCP, SFTP,
- SMTP, SMTPS, TELNET and TFTP.
+ FILE, FTP, FTPS, GOPHER, HTTP, HTTPS, IMAP, IMAPS, LDAP, POP3, POP3S, RTMP,
+ RTSP, SCP, SFTP, SMTP, SMTPS, TELNET and TFTP.
  .
  libcurl supports SSL certificates, HTTP POST, HTTP PUT, FTP uploading, HTTP
  form based upload, proxies, cookies, user+password authentication (Basic,

=== debian/rules ===
#! /usr/bin/make -f

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_BUILD_ARCH		?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_BUILD_ARCH_OS	?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
DEB_BUILD_GNU_TYPE	?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE	?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# set the number of build jobs
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    JOBS:=-j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE) --with-random=/dev/urandom
else
CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
    DO_TEST=no
else
    DO_TEST=no
    ifeq (${DEB_BUILD_GNU_TYPE},${DEB_HOST_GNU_TYPE})
    ifneq (${DEB_BUILD_ARCH},m68k)
    ifneq (${DEB_BUILD_ARCH_OS},kfreebsd)
    ifneq (${DEB_BUILD_ARCH_OS},knetbsd)
    ifneq (${DEB_BUILD_ARCH_OS},hurd)
        DO_TEST=yes
    endif
    endif
    endif
    endif
    endif
endif

CFLAGS   = $(shell dpkg-buildflags --get CFLAGS)
CFLAGS  += $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS  = $(shell dpkg-buildflags --get LDFLAGS)

# this will avoid unneded dependencies
LDFLAGS += -Wl,--as-needed

# this will catch miss-linking. (e.g. undefined symbols)
#LDFLAGS+= -Wl,-z,defs

CONFIGURE_ARGS = $(CROSS) --prefix=/usr --mandir=/usr/share/man	\
		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)	\
		--disable-dependency-tracking --enable-ipv6	\
		--with-lber-lib=lber --disable-symbol-hiding	\
		--enable-versioned-symbols --enable-manual	\
		--enable-debug --disable-curldebug		\
		CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"
# this is still not ready
#		--enable-ares
# this fixes the ldap warning of dpkg-shlibdebs, but we dont want that.
#		--with-ldap-lib=/usr/lib/libldap_r.so

ifneq (${DEB_BUILD_ARCH_OS},hurd)
CONFIGURE_ARGS += --with-gssapi=/usr
endif

build-arch: build-stamp
build-indep: build-stamp

build: build-arch build-indep

configure-stamp:
	dh_testdir
	mkdir -p debian/build debian/build-gnutls debian/build-nss
	# pop the last patch (nss)
	quilt pop
	# pop the second last patch (gnutls)
	quilt pop
	# get the source without nss and gnutls patches
	tar -cf - --exclude=debian --exclude=.pc . | tar -xf - -C debian/build
	# push the second last patch which must be gnutls
	quilt push
	# get the source with gnutls patch applied
	tar -cf - --exclude=debian --exclude=.pc . | tar -xf - -C debian/build-gnutls
	# push the last patch which must be nss
	quilt push
	# get the source with nss patch applied
	tar -cf - --exclude=debian --exclude=.pc . | tar -xf - -C debian/build-nss
	# run buildconf and make sure to copy the patched ltmain.sh
	for flavour in build build-gnutls build-nss; do \
		(cd debian/$$flavour && ./buildconf && cp ../../ltmain.sh .) \
	done
	cd debian/build && ./configure ${CONFIGURE_ARGS}		\
		--with-librtmp --with-ca-path=/etc/ssl/certs
	cd debian/build-gnutls && ./configure ${CONFIGURE_ARGS}		\
		--with-ca-bundle=/etc/ssl/certs/ca-certificates.crt	\
		--without-ssl --with-gnutls
	cd debian/build-nss && ./configure ${CONFIGURE_ARGS}		\
		--with-ca-bundle=/etc/ssl/certs/ca-certificates.crt	\
		--without-ssl --with-nss
	touch configure-stamp

build-stamp: configure-stamp
	dh_testdir
	${MAKE} $(JOBS) -C debian/build
	${MAKE} $(JOBS) -C debian/build-gnutls
	${MAKE} $(JOBS) -C debian/build-nss
ifeq (${DO_TEST},yes)
	-${MAKE} -C debian/build test
	-${MAKE} -C debian/build-gnutls test
	-${MAKE} -C debian/build-nss test
endif
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	$(RM) -r build-stamp configure-stamp debian/build* debian/tmp*

#install: DH_OPTIONS=
install: build-stamp
	dh_testdir
	dh_testroot
	dh_prep
	${MAKE} -C debian/build DESTDIR=$(shell pwd)/debian/tmp install
	${MAKE} -C debian/build-gnutls DESTDIR=$(shell pwd)/debian/tmp-gnutls install
	${MAKE} -C debian/build-nss DESTDIR=$(shell pwd)/debian/tmp-nss install
	dh_install -plibcurl3-gnutls -plibcurl4-gnutls-dev --sourcedir=debian/tmp-gnutls
	dh_install -plibcurl3-nss -plibcurl4-nss-dev --sourcedir=debian/tmp-nss
	dh_install -Nlibcurl3-gnutls -Nlibcurl4-gnutls-dev -Nlibcurl3-nss -Nlibcurl4-nss-dev --sourcedir=debian/tmp
	dh_lintian
	sed -i "/dependency_libs/ s/'.*'/''/" `find . -name '*.la'`

# Build architecture-independent files here.
binary-indep: build-stamp install
# We have nothing to do here.

# Build architecture-dependent files here.
binary-arch: build-stamp install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installman
	dh_installexamples
	dh_installchangelogs CHANGES
	dh_link
	dh_strip -Nlibcurl3 -Nlibcurl3-gnutls -Nlibcurl3-nss
	dh_strip -plibcurl3 -plibcurl3-gnutls -plibcurl3-nss --dbg-package=libcurl3-dbg
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_md5sums
	dh_gencontrol
	dh_builddeb

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep build clean install
